package cz.muni.fi.pv243.geocaching.aux;

import cz.muni.fi.pv243.geocaching.model.Cache;
import cz.muni.fi.pv243.geocaching.model.Coordinates;
import cz.muni.fi.pv243.geocaching.model.User;
import cz.muni.fi.pv243.geocaching.model.enums.CacheStatus;
import cz.muni.fi.pv243.geocaching.model.enums.CacheType;
import cz.muni.fi.pv243.geocaching.model.enums.Roles;

import javax.annotation.PostConstruct;
import javax.ejb.Singleton;
import javax.ejb.Startup;
import javax.inject.Inject;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.util.Date;

//import java.util.Date;

/**
 * This singleton EJB creates default users/other stuff in the database right after the application
 * gets deployed.
 */
@Singleton
@Startup
public class PopulateDatabaseAtStartupBean {

    @Inject
    private User testUser;

    @Inject
    private User testUser2;

    @Inject
    private Cache testCache;
    @Inject
    private Cache testCache1;
    @Inject
    private Cache testCache2;

    @PersistenceContext(unitName = "geocachingPU")
    private EntityManager em;
    
    @PostConstruct
    public void createUsers() {
        testUser.setUsername("testuser");
        testUser.setPassword("testpassword");
        testUser.addRole(Roles.REVIEWER);
        testUser.addRole(Roles.ADMIN);
        testUser.addRole(Roles.USER);
       em.persist(testUser);

        testUser2.setUsername("geocacher");
        testUser2.setPassword("geocacher");
        testUser2.addRole(Roles.USER);
        em.persist(testUser2);
        
        testCache.setName("first cache");
        testCache.setCacheType(CacheType.TRADITIONAL);
        testCache.setCoor(new Coordinates(2,3));
        testCache.setDifficulty(2);
        testCache.setTerrain(3);
        testCache.setOwner(testUser);
        testCache.setHidden(new Date());
        testCache.setListing("listing of first cache");
        em.persist(testCache);
        testCache1.setName("second keska");
        testCache1.setCacheType(CacheType.MYSTERY);
        testCache1.setCoor(new Coordinates(5,-3));
        testCache1.setDifficulty(5);
        testCache1.setTerrain(5);
        testCache1.setOwner(testUser);
        testCache1.setHidden(new Date());
        testCache1.setListing("listing of second cache");
        testCache1.setCacheStatus(CacheStatus.DISABLED);
        em.persist(testCache1);
        testCache2.setName("third cache");
        testCache2.setCacheType(CacheType.MULTI);
        testCache2.setCoor(new Coordinates(-2,-7));
        testCache2.setDifficulty(1);
        testCache2.setTerrain(2);
        testCache2.setOwner(testUser);
        testCache2.setHidden(new Date());
        testCache2.setListing("listing of third cache");
        testCache2.setCacheStatus(CacheStatus.ACTIVE);
        em.persist(testCache2);
    }

}
