package cz.muni.fi.pv243.geocaching.aux.logging;

import org.slf4j.LoggerFactory;
import org.slf4j.Logger;

import javax.enterprise.inject.Produces;
import javax.enterprise.inject.spi.InjectionPoint;

/**
 * Author: jmartisk
 * Date: 4/18/12
 * Time: 10:53 PM
 */
public class Loggers {

    @Produces
    public Logger produceLog(InjectionPoint injectionPoint) {
        if (injectionPoint.getAnnotated().isAnnotationPresent(Category.class)) {
            String category = injectionPoint.getAnnotated().getAnnotation(Category.class).value();
            return LoggerFactory.getLogger(category);
        } else {
            return LoggerFactory.getLogger(injectionPoint.getMember().getDeclaringClass());
        }
    }
}
