/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.pv243.geocaching.aux.logging;

import org.slf4j.Logger;

import javax.inject.Inject;
import javax.interceptor.AroundInvoke;
import javax.interceptor.Interceptor;
import javax.interceptor.InvocationContext;
import javax.persistence.Transient;

/**
 *
 * @author oja
 */
@Interceptor
@LogThis
public class LoggingInterceptor {
    
    @Inject
    @Transient
    private Logger logger;

    public LoggingInterceptor() {        
    }
    
    @AroundInvoke
    public Object log(InvocationContext ctx) {        
        String className = ctx.getTarget().getClass().getName();
        String methodName = ctx.getMethod().getName();
        Object[] parameters = ctx.getParameters();
        Object param = parameters[0];           
        logger.info(className + ", " + methodName + ": " + param.toString());
        try {
            return ctx.proceed();
        } catch (Exception ex) {
            logger.warn("Error calling ctx.proceed in LoggingInterceptor in method log()");            
            return null;
        }
    }
    
    
}
