/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.pv243.geocaching.caches;

import cz.muni.fi.pv243.geocaching.caches.crud.CacheManager;
import cz.muni.fi.pv243.geocaching.model.Cache;
import cz.muni.fi.pv243.geocaching.model.enums.CacheStatus;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.faces.event.ComponentSystemEvent;
import javax.inject.Inject;
import java.io.IOException;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 *
 * @author oja
 */
@ManagedBean(name = "archivedCachesManagedBean")
@ViewScoped
public class ArchivedCachesManagedBean implements Serializable {

    @Inject
    private CacheManager cm;
    
    private List<Cache> caches;
    
    public void initialize(ComponentSystemEvent event) {  
        caches = new ArrayList<Cache>();              
        Iterator it = cm.findAll().iterator();
        while (it.hasNext()) {
            Cache tempCache = (Cache)it.next();
            if (tempCache.getCacheStatus()==CacheStatus.ARCHIVED) {
                caches.add(tempCache);
            }
        }
    }
    
    public boolean cachesExists () {
        return caches!=null;        
    }
    
    public void activeCache(Cache cache) throws IOException {
        cache.setCacheStatus(CacheStatus.ACTIVE);
        cm.edit(cache);
        ExternalContext externalContext = FacesContext.getCurrentInstance().getExternalContext();
        externalContext.redirect("/reviewer/archivedcaches.xhtml");
    }

    public List<Cache> getCaches() {
        return caches;
    }

    public void setCaches(List<Cache> caches) {
        this.caches = caches;
    }
}
