/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.pv243.geocaching.caches.crud;

import cz.muni.fi.pv243.geocaching.aux.logging.LogThis;
import cz.muni.fi.pv243.geocaching.model.Cache;

import javax.ejb.Stateless;
import javax.faces.bean.ApplicationScoped;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;
import java.io.Serializable;
import java.util.List;

/**
 *
 * @author oja
 */
@Stateless
@ApplicationScoped
public class CacheManager implements Serializable {

    @PersistenceContext(unitName = "geocachingPU")
    private EntityManager em;
    
    public void create(Cache entity) {
        em.persist(entity);
    }
    
    @LogThis
    public void edit(Cache entity) {
        em.merge(entity);
    }
    
    @LogThis
    public void remove(Cache entity) {
        em.remove(em.merge(entity));
    }
    
    public Cache find(Integer id) {
        return em.find(Cache.class, id);
    }
    
    public List<Cache> findAll() {
        CriteriaQuery cq = em.getCriteriaBuilder().createQuery();
        cq.select(cq.from(Cache.class));
        return em.createQuery(cq).getResultList();
    }
    
    public int count() {
        CriteriaQuery cq = em.getCriteriaBuilder().createQuery();
        Root<Cache> rt = cq.from(Cache.class);
        cq.select(em.getCriteriaBuilder().count(rt));
        Query q = em.createQuery(cq);
        return ((Long) q.getSingleResult()).intValue();
    }
}
