/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.pv243.geocaching.caches.crud;

import cz.muni.fi.pv243.geocaching.model.enums.CacheType;
import cz.muni.fi.pv243.geocaching.session.LoggedInUserBean;
import cz.muni.fi.pv243.geocaching.model.*;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import java.io.IOException;
import java.util.Date;

/**
 *
 * @author oja
 */
@ManagedBean(name = "createCacheManagedBean")
@ViewScoped
public class CreateCacheManagedBean {
    
    @Inject
    private CacheManager cm;
    
    @Inject
    private LoggedInUserBean loggedBean;
    
    private String name;
    private int type;
    private int coorx;
    private int coory;
    private int difficulty;
    private int terrain;
    private String listing;
    
    @Inject
    private Cache cache;

    public void createCache () throws IOException {
        CacheType cacheType;
        switch(type) {
            case 1: cacheType = CacheType.TRADITIONAL; break;
            case 2: cacheType = CacheType.MULTI; break;
            case 3: cacheType = CacheType.MYSTERY; break;
            case 4: cacheType = CacheType.EARTH; break;
            case 5: cacheType = CacheType.LETTERBOX; break;
            default: cacheType = CacheType.TRADITIONAL; break;
        }
        User owner = loggedBean.getLoggedInUser();       
        cache.setName(name);
        cache.setCacheType(cacheType);
        cache.setCoor(new Coordinates(coorx,coory));
        cache.setDifficulty(difficulty);
        cache.setTerrain(terrain);
        cache.setOwner(owner);
        cache.setHidden(new Date());
        cache.setListing(listing);        
        
        cm.create(cache);             
        
        ExternalContext externalContext = FacesContext.getCurrentInstance().getExternalContext();
        externalContext.redirect("/cache.xhtml?cacheid="+cache.getId());
    }
    
    public boolean canBeRendered() {
        return loggedBean.getLoggedInUser()!=null;
    }

    public int getCoorx() {
        return coorx;
    }

    public void setCoorx(int coorx) {
        this.coorx = coorx;
    }

    public int getCoory() {
        return coory;
    }

    public void setCoory(int coory) {
        this.coory = coory;
    }

    public int getDifficulty() {
        return difficulty;
    }

    public void setDifficulty(int difficulty) {
        this.difficulty = difficulty;
    }

    public String getListing() {
        return listing;
    }

    public void setListing(String listing) {
        this.listing = listing;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getTerrain() {
        return terrain;
    }

    public void setTerrain(int terrain) {
        this.terrain = terrain;
    }

    public int getType() {
        return type;
    }

    public void setType(int type) {
        this.type = type;
    }
    
    
}
