/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.pv243.geocaching.caches.logs;

import cz.muni.fi.pv243.geocaching.caches.crud.CacheManager;
import cz.muni.fi.pv243.geocaching.model.enums.LogCacheType;
import cz.muni.fi.pv243.geocaching.session.LoggedInUserBean;
import cz.muni.fi.pv243.geocaching.model.*;
import java.io.IOException;
import java.io.Serializable;
import java.util.Date;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.faces.event.ComponentSystemEvent;
import javax.inject.Inject;

/**
 *
 * @author oja
 */
@ManagedBean(name = "logCacheManagedBean")
@ViewScoped
public class LogCacheManagedBean implements Serializable {
    
    @Inject
    private LogCacheManager lcm;
    
    @Inject
    private CacheManager cm;
    
    @Inject
    private LoggedInUserBean loggedBean;
    
    @Inject
    private LogCache logCache;
    
    private User user;
    private Cache cache;
    private String logText;
    private Date logDate;
    private int type;
    private String cacheCode;
    
    public void initialize(ComponentSystemEvent event) {
        cacheCode = FacesContext.getCurrentInstance().getExternalContext()
                .getRequestParameterMap().get("cacheid");
        if (cacheCode!=null) {       
            try {
                cache = cm.find(new Integer(cacheCode)); 
            } catch (NumberFormatException e) {
                cache = null;
            }
        }
    }
    
    public boolean cacheExists () {
        return cache!=null;        
    }
    
    public void processLog() throws IOException {
        LogCacheType logCacheType;
        switch(type) {
            case 1: logCacheType = LogCacheType.VISITED; break;
            case 2: logCacheType = LogCacheType.WRITENOTE; break;
            default: logCacheType = LogCacheType.WRITENOTE; break;
        }
        user = loggedBean.getLoggedInUser();
        logCache.setCache(cache);
        logCache.setUser(user);
        logCache.setLogText(logText);
        logCache.setLogDate(new Date()); // predelat
        logCache.setLogCacheType(logCacheType);
        lcm.create(logCache);
        ExternalContext externalContext = FacesContext.getCurrentInstance().getExternalContext();
        externalContext.redirect("/cache.xhtml?cacheid="+cache.getId());
    }
    
    public boolean canBeRendered() {
        return loggedBean.getLoggedInUser()!=null;
    }

    public Cache getCache() {
        return cache;
    }

    public void setCache(Cache cache) {
        this.cache = cache;
    }

    public String getCacheCode() {
        return cacheCode;
    }

    public void setCacheCode(String cacheCode) {
        this.cacheCode = cacheCode;
    }

    public LogCache getLogCache() {
        return logCache;
    }

    public void setLogCache(LogCache logCache) {
        this.logCache = logCache;
    }

    public Date getLogDate() {
        return logDate;
    }

    public void setLogDate(Date logDate) {
        this.logDate = logDate;
    }

    public String getLogText() {
        return logText;
    }

    public void setLogText(String logText) {
        this.logText = logText;
    }

    public int getType() {
        return type;
    }

    public void setType(int type) {
        this.type = type;
    }

    public User getUser() {
        return user;
    }

    public void setUser(User user) {
        this.user = user;
    }
    
    
}
