/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.pv243.geocaching.caches.logs;

import cz.muni.fi.pv243.geocaching.aux.logging.LogThis;
import cz.muni.fi.pv243.geocaching.model.LogCache;

import javax.ejb.Stateless;
import javax.faces.bean.ApplicationScoped;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.util.List;

/**
 *
 * @author oja
 */
@Stateless
@ApplicationScoped
public class LogCacheManager {
    
    @PersistenceContext(unitName = "geocachingPU")
    private EntityManager em;

    public void create(LogCache entity) {
        em.persist(entity);
    }

    @LogThis
    public void edit(LogCache entity) {
        em.merge(entity);
    }

    @LogThis
    public void remove(LogCache entity) {
        em.remove(em.merge(entity));
    }

    public LogCache find(Object id) {
        return em.find(LogCache.class, id);
    }

    public List<LogCache> findAll() {
        javax.persistence.criteria.CriteriaQuery cq = em.getCriteriaBuilder().createQuery();
        cq.select(cq.from(LogCache.class));
        return em.createQuery(cq).getResultList();
    }

    public int count() {
        javax.persistence.criteria.CriteriaQuery cq = em.getCriteriaBuilder().createQuery();
        javax.persistence.criteria.Root<LogCache> rt = cq.from(LogCache.class);
        cq.select(em.getCriteriaBuilder().count(rt));
        javax.persistence.Query q = em.createQuery(cq);
        return ((Long) q.getSingleResult()).intValue();
    }
}
