/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.pv243.geocaching.caches.search;

import cz.muni.fi.pv243.geocaching.caches.crud.CacheManager;
import cz.muni.fi.pv243.geocaching.session.LoggedInUserBean;
import cz.muni.fi.pv243.geocaching.model.Cache;
import cz.muni.fi.pv243.geocaching.model.enums.CacheStatus;
import cz.muni.fi.pv243.geocaching.model.Coordinates;
import java.util.*;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;
import javax.faces.context.FacesContext;
import javax.faces.event.ComponentSystemEvent;
import javax.inject.Inject;

/**
 *
 * @author oja
 */
@ManagedBean(name = "cachesManagedBean")
@ViewScoped
public class CachesManagedBean {
    
    @Inject
    private CacheManager cm;
    
    @Inject
    private LoggedInUserBean loggedBean;
    
    private List<Cache> caches;
    private Coordinates coor;
        
    public void initialize(ComponentSystemEvent event) {    
        caches = new ArrayList<Cache>();  
        int x;
        int y;
        try {            
            x = Integer.parseInt(FacesContext.getCurrentInstance().getExternalContext()
                .getRequestParameterMap().get("x"));
            y = Integer.parseInt(FacesContext.getCurrentInstance().getExternalContext()
                .getRequestParameterMap().get("y"));
        } catch(NumberFormatException ex) {        
            return;
        }        
        Iterator it = cm.findAll().iterator();
        while(it.hasNext()) {
            Cache tempCache = (Cache)it.next();
            if (tempCache.getCacheStatus()==CacheStatus.ACTIVE || 
                    tempCache.getCacheStatus()==CacheStatus.DISABLED) {
                caches.add(tempCache);
            }
        }
        coor = new Coordinates(x,y);
        Collections.sort(caches, new CompareDistance(coor)); 
    }
    
    public boolean canBeRendered() {
        return loggedBean.getLoggedInUser()!=null;
    }
    
    public boolean cachesExists () {
        return caches!=null;        
    }

    public List<Cache> getCaches() {
        return caches;
    }

    public void setCaches(List<Cache> caches) {
        this.caches = caches;
    }

    public Coordinates getCoor() {
        return coor;
    }

    public void setCoor(Coordinates coor) {
        this.coor = coor;
    }

    private class CompareDistance implements Comparator {
        
        private Coordinates coor;

        public CompareDistance(Coordinates coor) {
            this.coor = coor;
        }
        
        public int compare(Object o1, Object o2) {
             double result = ((Cache)o1).getCoor().distanceTo(coor)-((Cache)o2).getCoor().distanceTo(coor);
             if (result == 0) {
                 return 0;
             }
             if (result<0) {
                 return -1;
             } else {
                 return 1;
             }
        }
        
    }
}
