/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.pv243.geocaching.model;

import java.io.Serializable;
import java.util.Date;
import javax.inject.Inject;
import javax.persistence.*;

import cz.muni.fi.pv243.geocaching.model.enums.LogCacheType;
import org.slf4j.Logger;

/**
 *
 * @author oja
 */
@Entity
@Table(name="LogCache")
public class LogCache implements Serializable {
    
    @Inject
    @Transient
    private Logger logger;
    
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Integer id;
    
    @ManyToOne
    private User user;
    
    @ManyToOne
    private Cache cache;
    
    private String logText;
    @Temporal(javax.persistence.TemporalType.DATE)
    private Date logDate;
    private LogCacheType logCacheType;
    
    @PostPersist    
    public void logCreation() {
        logger.info("Created new log of cache: " + this.toString());
    }

    public LogCache() {
    }

    public LogCache(User user, Cache cache, String logText, Date logDate) {
        this.user = user;
        this.cache = cache;
        this.logText = logText;
        this.logDate = logDate;
    }

    public Cache getCache() {
        return cache;
    }

    public void setCache(Cache cache) {
        this.cache = cache;
    }

    public Date getLogDate() {
        return logDate;
    }

    public void setLogDate(Date logDate) {
        this.logDate = logDate;
    }

    public String getLogText() {
        return logText;
    }

    public void setLogText(String logText) {
        this.logText = logText;
    }

    public User getUser() {
        return user;
    }

    public void setUser(User user) {
        this.user = user;
    }

    public LogCacheType getLogCacheType() {
        return logCacheType;
    }

    public void setLogCacheType(LogCacheType logCacheType) {
        this.logCacheType = logCacheType;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {        
        if (!(object instanceof LogCache)) {
            return false;
        }
        LogCache other = (LogCache) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "Log of cache{" +
                "id=" + id +
                ", cache=" + cache.getName() +
                ", user=" + user.getUsername() +
                ", logText=" + logText +
                ", logDate=" + logDate +
                '}';
    }
    
}
