package cz.muni.fi.pv243.geocaching.session;

import org.slf4j.Logger;

import javax.inject.Inject;
import javax.servlet.annotation.WebListener;
import javax.servlet.http.HttpSessionEvent;
import javax.servlet.http.HttpSessionListener;

/**
 * Author: jmartisk
 * Date: 6/8/12
 * Time: 8:53 AM
 */
@WebListener
public class WebSessionListener implements HttpSessionListener
{
    @Inject
    private Logger logger;

    @Override
    public void sessionCreated(HttpSessionEvent httpSessionEvent) {
        logger.info("HTTP session created: " + httpSessionEvent.getSession().getId());
        while(httpSessionEvent.getSession().getAttributeNames().hasMoreElements()) {
            String s = httpSessionEvent.getSession().getAttributeNames().nextElement();
            logger.info(s);
        }
    }

    @Override
    public void sessionDestroyed(HttpSessionEvent httpSessionEvent) {
        logger.info("HTTP session ended: " + httpSessionEvent.getSession().getId());
    }

}