/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.pv243.geocaching.users;

import cz.muni.fi.pv243.geocaching.model.User;
import cz.muni.fi.pv243.geocaching.model.enums.Roles;
import org.slf4j.Logger;

import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.validation.constraints.Size;
import java.io.IOException;

/**
 *
 * @author jmartisk
 */
@ManagedBean(name = "createUserManagedBean")
@ViewScoped
public class CreateUserManagedBean {

    @Inject
    UserManager manager;

    @Inject
    private Logger logger;



    public void setPasswordAgain(String passwordAgain) {
        this.passwordAgain = passwordAgain;
    }

    private String passwordAgain;
    private String password;

    public User getUser() {
        return user;
    }

    @Inject
    private User user;


    public String register() throws IOException, InterruptedException {
        if(!User.hashPassword(passwordAgain).equals(User.hashPassword(password))) {
            FacesContext.getCurrentInstance().addMessage("Passwords do not match", new FacesMessage("Entered passwords do not match"));
            return null;
        }
        user.setPassword(password);
        user.addRole(Roles.USER);
        try {
            manager.registerUser(user);
        } catch (Exception e) {
            logger.error(e.toString());
            FacesContext.getCurrentInstance().addMessage("Error: "+e.getMessage(), new FacesMessage("Error: "+e.getMessage()));
            return null;
        }
        Thread.sleep(300);
        FacesContext.getCurrentInstance().getExternalContext().redirect("/loginServlet?username="+user.getUsername()+"&password="+password);
        return null;
    }

    public String getPasswordAgain() {
        return passwordAgain;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    @Size(min = User.MINIMUM_PASSWORD_LENGTH, max = User.MAXIMUM_PASSWORD_LENGTH)
    public String getPassword() {
        return password;
    }
}
