/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.pv243.geocaching.users;

import cz.muni.fi.pv243.geocaching.caches.crud.CacheManager;
import cz.muni.fi.pv243.geocaching.caches.logs.LogCacheManager;
import cz.muni.fi.pv243.geocaching.session.LoggedInUserBean;
import cz.muni.fi.pv243.geocaching.model.Cache;
import cz.muni.fi.pv243.geocaching.model.LogCache;
import cz.muni.fi.pv243.geocaching.model.enums.LogCacheType;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;
import javax.faces.event.ComponentSystemEvent;
import javax.inject.Inject;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 *
 * @author oja
 */
@ManagedBean(name = "userManagedBean")
@ViewScoped
public class UserManagedBean implements Serializable {

    @Inject
    private CacheManager cm;
    
    @Inject
    private LogCacheManager lcm;
    
    @Inject
    private LoggedInUserBean loggedBean;
    
    private List<Cache> foundCaches;
    private List<Cache> ownersCaches;
    
    private int foundNumber = 0;
    
    public void initialize(ComponentSystemEvent event) {
        if (loggedBean.getLoggedInUser()!=null) {            
            ownersCaches = new ArrayList<Cache>();
            Iterator it = cm.findAll().iterator();
            while (it.hasNext()) {
                Cache tempCache = (Cache)it.next();
                if (tempCache.getOwner().getUsername().equals(loggedBean.getLoggedInUser().getUsername())) {
                    ownersCaches.add(tempCache);
                }
            }
            foundCaches = new ArrayList<Cache>();
            Iterator it1 = lcm.findAll().iterator();
            while (it1.hasNext()) {
                LogCache log = (LogCache)it1.next();
                if (log.getUser().getUsername().equals(loggedBean.getLoggedInUser().getUsername()) 
                        && log.getLogCacheType()==LogCacheType.VISITED) {
                    foundCaches.add(log.getCache());
                    foundNumber++;
                }
            }      
        }
    }
    
    public boolean canBeRendered() {
        return loggedBean.getLoggedInUser()!=null;
    }
    
    public boolean foundCachesExists() {
        return foundCaches!=null;
    }
    
    public boolean ownersCachesExists() {
        return ownersCaches!=null;
    }

    public List<Cache> getFoundCaches() {
        return foundCaches;
    }

    public void setFoundCaches(List<Cache> foundCaches) {
        this.foundCaches = foundCaches;
    }

    public int getFoundNumber() {
        return foundNumber;
    }

    public void setFoundNumber(int foundNumber) {
        this.foundNumber = foundNumber;
    }

    public List<Cache> getOwnersCache() {
        return ownersCaches;
    }

    public void setOwnersCache(List<Cache> ownersCache) {
        this.ownersCaches = ownersCache;
    }
       
    
}
