package cz.muni.fi.pv243.geocaching;

import cz.muni.fi.pv243.geocaching.aux.logging.Category;
import cz.muni.fi.pv243.geocaching.aux.logging.Loggers;
import junit.framework.Assert;
import org.jboss.arquillian.container.test.api.Deployment;
import org.jboss.arquillian.junit.Arquillian;
import org.jboss.shrinkwrap.api.ArchivePaths;
import org.jboss.shrinkwrap.api.ShrinkWrap;
import org.jboss.shrinkwrap.api.asset.EmptyAsset;
import org.jboss.shrinkwrap.api.spec.JavaArchive;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.slf4j.Logger;

import javax.inject.Inject;

/**
 * Author: jmartisk
 * Date: 4/18/12
 * Time: 11:56 PM
 */
@RunWith(Arquillian.class)
public class LoggerInjectionTest {

    private static final String CATEGORY = "cat1";

    @Inject
    @Category(CATEGORY)
    private Logger logger;

    @Deployment
    public static JavaArchive deploy() {
        return ShrinkWrap.create(JavaArchive.class, "logger-injection.jar")
                .addPackage(Loggers.class.getPackage())
                .addAsManifestResource(
                        EmptyAsset.INSTANCE,
                        ArchivePaths.create("beans.xml"));
    }

    @Test
    public void checkThatLoggerWasInjected() throws Exception {
        Assert.assertNotNull("Default Logger should have been injected", logger);
        Assert.assertEquals("Custom logger category was requested", CATEGORY, logger.getName());
    }

}
